<?php
/*!! Structure.Kernel.Wacko, Function.WikiPages:
*  {{ontolink name="System.Structure.Kernel.WackoOld" text="WackoOld"}}.
*   Wacko -    .  
*  *  e  ( QSMini)
*  *      ( INIT)
*  *  ,   AJAX-,       .
* @param $config    .     wakka.config.php
*/

class Wacko extends WackoOld {
  var $ext_services="";
  var $ext_userinfo="";
  var $ext_usinfoload=0;
  var $do_time=0;
  var $atheme;
  var $aactions = array();
  var $acontent = false;
  var $extmodules = 0;

  var $cntid = 0;
  var $cntmax = 0;
  var $cntarr = array();

// Base features
  function Wacko($config) {
    $this->WackoOld($config);
    $this->_formatter_noautolinks = true;

    // Adding different services



    /*
    foreach($res as $service) {
       $servname = $service["name"];
       $this->ServiceRunFile($servname,'init');
    }
    */
    $this->srvAllRunFile('init');

    // Using Ajax

    if($this->IsAjax()) {
        require_once($this->classes_dir."dyn.php");
        $JsHttpRequest =& new Subsys_JsHttpRequest_Php("windows-1251");
        GLOBAL $_RESULT;
        $_RESULT["ajaxsysmsg"] = "";
        $this->atheme = explode(";",$_REQUEST["divname"]);
        $this->aactions = explode(";",$_REQUEST["actions"]);

        if($this->atheme[0] == "content") {
            unset($this->atheme[0]);
            $this->acontent = true;
        }

        foreach($this->atheme as $key => $val) {
          if(!preg_match("/^\\w+$/",$val)) {
              unset($this->atheme[$key]);
          }
        }

        foreach($this->aactions as $key => $val) {
          if(!preg_match("/^\\w+$/",$val)) {
              unset($this->aactions[$key]);
          }
        }
    } else {
      $this->acontent = true;
    }

  }

//--------------------------------- WikiUpdate -------------------------------

/*!! Structure.Kernel.Wacko.RemoveActions, Function.Plugin:
*   ,   .          .
*       .      
* @param $pgid ID 
*/

  function RemoveActions($pgid) {
     $this->Query('DELETE FROM '.$this->config["table_prefix"]."actions WHERE page_id='".quote($pgid)."'");
  }

/*!! Structure.Kernel.Wacko.CanAction, Function.Access, Function.Plugin:
*  ,       .       actions.
* @param $action   (   ,   - )
* @param $pageid ,     
* @param $cond     SQL-.   .
* @return dbrow -   ,     ,    .        .
*/

  function CanAction($action,$pageid,$cond="") {
    return $this->Loadsingle("SELECT * FROM ".$this->config["table_prefix"]."actions WHERE actiontype='".quote($action)
    ."' AND page_id='".quote($pageid)."' ".$cond);
  }

/*!! Structure.Kernel.Wacko.CanThisPageAction, Function.Plugin, Function.Access, User.Admin:
*  ,        .  ,    ,              .
*          ,  .   TRUE   $this->cur_security.
*         .
* @param $action   (   ,   - )
* @return dbrow -   ,     ,    .        .
*/

  function CanThisPageAction($action) {
     $canact = $this->CanAction($action,$this->page["id"]);
     if($this->IsAdmin()) {
         if($canact!="") {
            if($_GET["del".$action]) {
               $this->Query("DELETE FROM ".$this->config["table_prefix"]."actions WHERE id='".quote($canact["id"])."'");
               $this->SetMessage("Action $action has been uninstalled.");
               $this->redirect($this->href());
            } else {
               echo "<table border=0 width=100%><tr><td align='center'>Action $action installed. <a href=\"".$this->Href("","","del".$action."=1")."\">Uninstall</a></td></tr></table><br />";
            }
         } else {
            if($_GET["add".$action]) {
               $this->Query("INSERT INTO ".$this->config["table_prefix"]."actions SET page_id='".quote($this->page["id"])."', actiontype='".quote($action)."'");
               $this->SetMessage("Action $action has been installed.");
               $this->redirect($this->href());
            } else {
               echo "<table border=0 width=100%><tr><td align='center'>Action $action not installed. <a href=\"".$this->Href("","","add".$action."=1")."\">Install</a></td></tr></table><br />";
            }

         }
     }
     return $canact || $this->cur_security;
  }

/*!! Structure.Kernel.Wacko.AddSimpleSpaces, Function.Other:
*       .
* @param string -
*/

   // formatter functions

   function AddSimpleSpaces($text) {
     return str_replace('&nbsp;',' ',$this->AddSpaces($text));
   }

   /**
   * @ignore
   */

   function LoadTopPages() {
       $pages = $this->LoadAll("select ".$this->pages_meta." from ".
           $this->config["table_prefix"]."pages where supertag rlike '^[A-Za-z_\\']*\$'".
           " and comment_on = ''");
       if ($pages){
          $this->CacheACLPages($pages);
          return $pages;
       }
   }

   /**
   * @ignore
   */

   function CacheACLPages(&$pages) {
          //       acl
          foreach($pages as $page){
            $this->CachePage($page, 1); // ??   
            $supertag_list[] = $page["supertag"];
          }

          //    acl
          for ($i=0; $i<count($supertag_list); $i++) {
            $supertag_str .= "'".quote($supertag_list[$i])."', ";
          }
          $supertag_str=substr($supertag_str,0,strlen($supertag_str)-2);

          //  
          if ( $read_acls = $this->LoadAll("select * from ".$this->config["table_prefix"]."acls where supertag in (".$supertag_str.") and privilege = 'read'")){
          for ($i=0; $i<count($read_acls); $i++) {
            $this->CacheACL($read_acls[$i]["supertag"], "read", 1,$read_acls[$i]);
          }
          }
   }

/*!! Structure.Kernel.Wacko.LoadIdByTag, Function.WikiPages:
*  (   )  ID    .
*/


   function LoadIdByTag($tag) {
     $pg=$this->LoadSingle('SELECT id FROM '.$this->config["table_prefix"]."pages WHERE tag='".quote($tag)."'");
     return $pg["id"];
   }

/*!! Structure.Kernel.Wacko.UseAutoJs, Function.Theme:
*   HTML,   JS-   'js/autoinc'.
*/
   function UseAutoJs() {
     $dir_pointer=opendir('js/autoinc');
     while ($res = readdir($dir_pointer)) {
       if(strstr($res,'.js')) {
          ?>
          <script language="javascript" type="text/javascript" src="<?php echo $this->GetConfigValue("root_url")."js/autoinc/".$res; ?>"></script>
          <?php
       }
     }
   }


/*!! Structure.Kernel.Wacko.srvAllMakeJS, Function.Extension:
*      MAKEJS,      "js/autoinc/autoext.js".   
*    JS   , ,   .
*/

   function srvAllMakeJS() {
     $cont = "";
     $res=$this->srvLoadAll();

     foreach($res as $service) {
       $servname = $service["name"];
       $cont .= "\n// ---- service ".$servname." ---- \n";
       $cont .= $this->srvRunFileContent($servname,'makejs');
     }
     $fp = fopen('js/autoinc/autoext.js','w');
     fwrite($fp,$cont);
     fclose($fp);
   }


   // load language resources
/*!! Structure.Kernel.Wacko.srvAllLoadResource, Function.Config:
*     .
*/

   function srvAllLoadResource($lang,&$wackoResource) {
     $res=$this->srvLoadAll();
     foreach($res as $service) {
       $servname = $service["name"];
       //$this->ServiceRunFile($servname,$filename);
       if(file_exists('extensions/'.$servname.'/lang/wakka.'.$lang.'.php')) {
          include('extensions/'.$servname.'/lang/wakka.'.$lang.'.php');
          $wackoResource = array_merge((array)$wackoResource, (array)$serviceResource);
       }
     }
   }

//--------------------------------- AJAX -------------------------------

/*!! Structure.Kernel.Wacko.ajxElement, Function.AJAX, Function.Theme:
*   ,    "< >/elements".
* @param $elem     
* @return string   
*/

   function ajxElement($elem, $forceLinkTracking = 0)
   {
      $elem = trim($elem);
      //if (!$forceLinkTracking) $this->StopLinkTracking();
      $result = $this->IncludeBuffered(strtolower($elem).".php", "<i>Unknown block \"".strip_tags($elem)."\"</i>", "", "themes/".$this->GetConfigValue("theme")."/elements");
      //$this->StartLinkTracking();
      return $result;
   }

/*!! Structure.Kernel.Wacko.ajxElementsAllRun, Function.AJAX, Function.Theme:
*    .
* @link Version.QS.v3s1:
*     .    .
*/


   function ajxElementsAllRun()
   {
      global $_RESULT;
      $allElements = array();
      $dir_pointer=opendir("themes/".$this->GetConfigValue("theme")."/elements");
      while ($res = readdir($dir_pointer)) {
      if(strstr($res,'.php')) {
         $res1 = str_replace(".php","",$res);
         $allElements[$res1] = $this->ajxElement($res1);
      }
      }
      return $allElements;
   }


/*
   function JsElement($element) {
     return "document.getElementById('".$element."').innerHTML = req.responseJS.".$element.";\n";
   }
*/

/*!! Structure.Kernel.Wacko.ajxPhpElement, Function.AJAX, Function.Theme:
*   AJAX-       .
*/

   function ajxPhpElement($element) {
     global $_RESULT;
     $_RESULT[$element]=$this->ajxElement($element);

   }


/*!! Structure.Kernel.Wacko.IsAjax, Function.AJAX:
* ,       AJAX
* @return boolean
*/

   function IsAjax() {
     return $_GET["sender"]=="AJAX";
   }

/*!! Structure.Kernel.Wacko.StartVirtual, Function.AJAX, Function.Actions:
*       AJAX.     FinishVirtual.
*/

   function StartVirtual() {
     ob_start();
   }

/*!! Structure.Kernel.Wacko.FinishVirtual, Function.AJAX, Function.Actions:
*     AJAX.  ,    StartVirtual  FinishVirtual ,  ,
*     AJAX   $kname,   .
* @param $kname  AJAX-.   ,     .
*/
   function FinishVirtual($kname) {
     GLOBAL $_RESULT;
     $output = ob_get_contents();
     ob_end_clean();
     echo $output;
     //$key = array_search($kname, $this->aactions);
     /*if ($key!=false) {
     //if(in_array($kname, $this->aactions)) {
        $_RESULT[$kname] = $output;
        //unset($this->aactions[$key]);
     }
     */
     foreach($this->aactions as $key => $val) {
          if($val==$kname) {
              $_RESULT[$kname] = $output;
              unset($this->aactions[$key]);
          }
      }
   }

/*!! Structure.Kernel.Wacko.ajxDynAction, Function.AJAX, Function.Actions:
*      AJAX- .
* @param string  .
* @param string   .
* @param integer   0,    .     .
* @link Examples.AJAX:
 2.    AJAX.   -     .
%%(php)
<?php
  //  
  $id = 'action'.$this->cntGetOne();
  echo $this->ajxDynAction($id,date('H:i:s'),'3000');
?>
%%
*/

   function ajxDynAction($id, $content, $timeout=0) {
      echo "<div id='".$id."'>";
        $this->StartVirtual();
           echo $content;
         if($timeout!=0) $this->ajxAddJs("setTimeout(\"doDyn('','','".$id."','');\",".$timeout.");");
        $this->FinishVirtual($id);
      echo "</div>";
   }

/*!! Structure.Kernel.Wacko.Arefresh, Function.AJAX, Function.Actions:
*    AJAX,          .
*/


   function Arefresh() {
     if ($this->IsAjax()) {
       //echo "<script language=\"javascript\" onload=\"doDyn(curpage,'','','');\"></script>";
       $this->AddJs("doDyn('',thelements,'','');");
     } else {
       $this->redirect($this->href());
     }
   }

   /**
   * @ignore
   */

   function AddJs($oper) {
     if ($this->IsAjax()) {
       //echo "<script language=\"javascript\" onload=\"doDyn(curpage,'','','');\"></script>";
       GLOBAL $_RESULT;
       $_RESULT["ajaxsysmsg"] .= $oper;
     } else {
       //;
     }
   }

/*!! Structure.Kernel.Wacko.ajxAddJs, Function.AJAX:
*     JS    ,  AJAX  ,  .
* @param string JS-.
*/

   function ajxAddJs($oper) {
     $this->AddJs($oper);
     if(!$this->IsAjax()) {
          ?>
            <script language="JavaScript" type="text/javascript">
            <?php echo $oper; ?>
            </script>
          <?php
     }
   }

/*!! Structure.Kernel.Wacko.ajxHref, Function.AJAX:
*  ,      AJAX-.
* @param string URL,    .
* @param string  -,  ';'
* @param string  
* @param string  ; ID ,    .
* @return string HTML- 
*/

   function ajxHref($href, $action, $text, $form = "") {
     return '<a href="'.$href.'" onclick="return doDyn(\''.quote($href)."','','".$action."','".$form."')\">".$text."</a>";
   }

/*!! Structure.Kernel.Wacko.ajxFormOpen, Function.AJAX:
*  ,   AJAX-.
* @param string  ID 
* @param string     ,  ';'
* @param string  -  ,  ';'
* @return string HTML-,  
*/

   function ajxFormOpen($id,$thref,$actref) {
     return '<form id="'.$id.'" method="GET" onsubmit="return doDyn('."'','".quote($thref)."','".$actref."','".$id."');\">";
   }

//--------------------------------- Primitives -------------------------------

   // Virtual Forms functions
/*!! Structure.Kernel.Wacko.vfrmField, Function.VirtualForm:
*    .
*       .     
* "vfrm"()   $this->vfrm["state"] = "field", ,   
*  .
* @param string ,          ()
* @param string  .       ,  "int"  "int low=0 high=100"
* @param string ,  , ,    .
* @return string      .
*/
   function vfrmField($name,$type,$value) {
      // Prepare parameters to move to procedure. Because we call Format, we can't move it in procedure, and write it in global array.
      $this->vfrm = array();
      $this->vfrm["state"] = "field";
      $this->vfrm["name"] = $name;
      $this->vfrm["value"] = $value;

      $str = $this->Format('vfrm'.$type.'','post_wacko');

      $this->vfrm = array();
      return $str;
      /*
      if(($type=="int") || ($type=="text")) {
        return '<input type="text" name="'.$name.'" value="'.$value.'">';
      }
      if($type=="textarea") {
        return '<textarea name="'.$name.'" rows="6" cols="7" style="width: 100%">'.$value.'</textarea>';
      }
      if($type=="spawhtml") {
        ob_start();
        $sw = new SPAW_Wysiwyg($name,$value,'ru','full');
        $sw->show();
        $output = ob_get_contents();
        ob_end_clean();
        return $output;
      }
      */
   }

/*!! Structure.Kernel.Wacko.vfrmProcess, Function.VirtualForm:
*    .
*       $name      $type.
* @param string  .       ,  "int"  "int low=0 high=100"
* @param string  ()  .
* @return string      .
*/
   function vfrmProcess($type,$name) {
      // Prepare parameters to move to procedure. Because we call Format, we can't move it in procedure, and write it in global array.
      $this->vfrm = array();
      $this->vfrm["state"] = "process";
      $this->vfrm["name"] = $name;

      $str = $this->Format('vfrm'.$type.'','post_wacko');

      $this->vfrm = array();
      return $str;

      /*
      $value = $_REQUEST[$name];
      if($type=="int") {
              return (int)$value;
      }
      if(($type=="text") || ($type=="textarea")) {
           return str_replace('#>','#&gt;',$value);
      }
      if($type=="spawhtml") {
          return str_replace('#>','#&gt;',$value);
      }
      */
   }

/*!! Structure.Kernel.Wacko.vfrmActionState, Function.VirtualForm:
*    .
*   ,  ,    ,      ("vfrm*.php").   "field",    , "process" -    .
* @return string "field"|"process" - .  .
*/
   function vfrmActionState() {
     return $this->vfrm["state"];
   }

/*!! Structure.Kernel.Wacko.cntReserve, Function.Other.IdGen:
*    -       ,  ,
*   cntGet,    .
* @param integer -  
*/

   function cntReserve($num) {
      $this->cntid++;
      $this->cntarr[$this->cntid]['base'] = $this->cntmax;
      $this->cntarr[$this->cntid]['cur'] = $num;
      $this->cntmax += $num;
      return $this->cntid;
   }

/*!! Structure.Kernel.Wacko.cntGet, Function.Other.IdGen:
*      ,   cntReserve.   
*    ,  die();
* @param key ,  cntReserve;
*/

   function cntGet($id) {
      if (0>=$this->cntarr[$id]['cur']) {
          echo 'Error in cntGet: too much identificators';
          die();
      }
      $res = $this->cntarr[$id]["base"]+$this->cntarr[$id]["cur"];
      $this->cntarr[$id]["cur"]--;
      return $res;
   }

/*!! Structure.Kernel.Wacko.cntGetOne, Function.Other.IdGen:
##function cntGetOne()##
*    .        ,        1 .
*/

   function cntGetOne() {
      $this->cntmax++;
      return $this->cntmax;
   }

/*!! Structure.Kernel.Wacko.NewSmarty, Function.Libs.Smarty:
##function NewSmarty()##
   Smarty.
*/

   function NewSmarty() {
      require_once(SMARTY_DIR.'Smarty.class.php');
      return new Smarty;
   }

//--------------------------------- Documentation -------------------------------

   // Recomendation functions
   /**
   *  .
   * @param $id ,    JS-.
   * @param $text  
   * @param $solution  
   * @param $level  : [critical|possible]
   */

   function docShowRecom($id,$text,$solution,$level = "critical") {
      $text = $this->Format($text);
      $solution = $this->Format($solution);
      if($level == "critical") {
          $color = '#F00';
      }
      if($level == "possible") {
          $color = '#22F';
      }
      $restext = '<div style="color: '.$color.'; ">'.$text.'</div>';
      echo '<div>'.$restext.'<div style="text-align: right;"><small><a href="'.$this->href().'" onclick="return ShowHideById(\''.$id.'\');">'.$this->GRV('rec.showsolution').'</a></small></div></div>';
      echo '<div id="'.$id.'" style="display: none; padding: 20px;">'.$solution.'</div>';
   }

   /**
   *    HTML-,      .
   * @param $docpath   
   */

   function docClearFolder($docpath) {
      $this->utilClearFolder($docpath,'.html');
    }

   /**
   *  
   * @param $files ,   ,     .
   * @param $docpath   
   */

    function docGen($files,$docpath) {
       $directory = $docpath;
       include("lib/phpdoc/phpdoc.php");
    }

//--------------------------------- Other -------------------------------

   // XML functions
   /**
   * @ignore
   */

   function VSXMLLoad($data,$keyname) {
    //  xml  
    $parser = xml_parser_create();
    xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
    xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
    xml_parse_into_struct($parser,$data,$values,$tags);
    xml_parser_free($parser);

    //    
    foreach ($tags as $key=>$val) {
        if ($key == $keyname) {
            $molranges = $val;
            //        
            //      
            for ($i=0; $i < count($molranges); $i+=2) {
                    $offset = $molranges[$i] + 1;
                $len = $molranges[$i + 1] - $offset;
                $tdb[] = $this->VSXMLParse(array_slice($values, $offset, $len));
            }
        } else {
            continue;
        }
    }
    return $tdb;
    }

   /**
   * @ignore
   */
    function VSXMLParse($mvalues) {
    for ($i=0; $i < count($mvalues); $i++)
        $mol[$mvalues[$i]["tag"]] = $mvalues[$i]["value"];
    return $mol;
    }

/*!! Structure.Kernel.Wacko.OneButtonAction, Function.Other, Function.Actions:
##function OneButtonAction($btnid,$btntext)##
   ,   .
*/
    function OneButtonAction($btnid,$btntext) {
      if($_REQUEST["run_".$btnid]!='1') {
        echo $this->FormOpen();
        echo '<input type=hidden name="run_'.$btnid.'" value=1>';
        echo '<input type=submit value="'.$btntext.'">';
        echo $this->FormClose();
        return false;
      } else {
        return true;
      }
    }

}

//Autoinclude files from 'autoinc'

$dir_pointer=opendir('classes/autoinc');
while ($res = readdir($dir_pointer)) {
  if(strstr($res,'.php')) {
     require_once('autoinc/'.$res);
  }
}




?>
